<?php

/**
 * Partial Filter for {@link http://haml-lang.com/ Haml} class.
 * The text will be parsed with the PHP interpreter.
 * @package			PHamlP
 * @subpackage	Haml.filters
 */
class HamlPartialFilter extends HamlBaseFilter {
	/**
	 * Run the filter
	 * @param string text to filter
	 * @return string filtered text
	 */
	public function run($text) {
		$partial = yaml::fromString($text);
		if (isset($partial['name']) && $partial['name'])
			return <<<QQQ
<? 
\$__actionfile = \$benyx->resolveActionFile('$partial[name]');
if (file_exists(\$__actionfile))
{
	benyx_log("partial|Execute: \$__actionfile");
	include \$__actionfile;
}
include haml::partial('$partial[name]'); 
?>
QQQ;
		else
			return "\n<?php include haml::partial(); ?>";
	}
}
