<?
// under General Public License
// skeletic ver 4.1 (c) Cosinus
// http://klavasoft.com
// Minimalistic PHP framework
//


	skeletic_base::init();
	skeletic_base::create_sk();
	ob_start();
	if (isset(sk::$section['action']))
		require sk::$root."/actions/".sk::$section['action'];
			
	$__view_ext = strrchr(sk::$section['view'],'.');
	if ($__view_ext=='.haml')
	{
		require_once "inc/haml.inc.php";
		sk::$haml = new HamlParser2(array());
		eval("?".">".sk::$haml->parse(sk::$root."/views/".sk::$section['view']));
	}
	elseif ($__view_ext=='.html')
		readfile(sk::$root."/views/".sk::$section['view']);
	elseif ($__view_ext=='.php')
		require sk::$root."/views/".sk::$section['view'];
	else
		throw new Exception('View file type is not supported: '.sk::$section['view']);
	sk::$page = ob_get_contents();
	ob_end_clean();
// including layout
	$__layout = sk::$section['layout'];
	$__layout_ext = strrchr($__layout,'.');
	sk::log("layout=$__layout");
	if ($__layout_ext=='.haml')
	{
		require_once "inc/haml.inc.php";
		if (!$sk::$haml) sk::$haml = new HamlParser2(array());
		eval("?".">".sk::$haml->parse(sk::$root."/views/".$__layout));
	}
	elseif($__layout_ext=='.php')
		require sk::$root."/views/".$__layout;
	else
		trigger_error('Layout file type is not supported: '.sk::$config['section'],E_USER_ERROR);
	
	
class skeletic_base
{
	static $data;
	static $root;
	static $haml;
	static $page;
	static $config = false;
	static $item = false;
	static $section = false;
	static $param1;

	static function log($s)
	{
		if (isset(self::$config['logfile']))
		{
			if ( is_writable(self::$config['logfile']))
			{
				if ($s)
					error_log(date('Y-m-d H:i:s ').$s."\n",3,self::$config['logfile']);
				else
					error_log("\n",3,self::$config['logfile']);
			}
			else
			{
				trigger_error("Logfile is not writable: ".@self::$config['logfile']);
				die();
			}
		}
	}
	
	static function init()
	{
		$file = strtr(__FILE__,'\\','/');
		self::$root = substr(__FILE__,0,strrpos($file,'/'));
		$er = error_reporting();
		$de = ini_get('display_errors');
		error_reporting(E_ALL);
		ini_set('display_errors',1);
		self::$data = parse_ini_file('skeletic.ini', true);			
		self::$config = self::$data['_config_'];
		self::log('');
		self::log($_SERVER['REQUEST_METHOD'].' '.$_SERVER['REQUEST_URI']);
		$mypath = str_replace('/index.php','',strtr(__FILE__,'\\','/'));
		$root = self::$config['base']=='.' || self::$config['base']=='./';
		if (!$root && strpos(strrev($mypath),strrev(self::$config['base']))!==0)
		{
			header("HTTP/1.1 500 _config_ base directive looks like invalid.");
			die('_config_ base directive looks like invalid.');
		}
		unset(self::$data['_config_']);
		foreach(self::$data as $item=>$section)
		{
			self::log('Analizing section: '.self::$section['method'].' '.$section['url']);
			if (isset($section['method']) && strtoupper($section['method'])!=$_SERVER['REQUEST_METHOD']) continue;
			$req_uri = str_replace('?'.$_SERVER['QUERY_STRING'],'',$_SERVER['REQUEST_URI']);
			$pbase = strpos($req_uri,self::$config['base']);
			if ($pbase===0)
				$req_uri = str_replace(self::$config['base'],'',$req_uri);
			if (substr($section['url'],-1)=='*')
				if (strpos($req_uri,substr($section['url'],0,-1))===0)
				{ // url like /?product=* or /product/*
					self::log('Wild URI matched: '.$req_uri);
					self::$item = $item;
					self::$section = $section;
					$params = explode('/',str_replace(substr($section['url'],0,-1),'',$req_uri));
					for($i=1; $i<=count($params); $i++) 
						$GLOBALS['param'.$i] = $params[$i-1];
					break;
				}
			if ($section['url']==$req_uri)
			{
				self::log('Strict URI matched: '.$req_uri);
				self::$item = $item;
				self::$section = $section;
				break;
			}
		}
		error_reporting($er);
		ini_set('display_errors',$de);

		if (!self::$item)
		{ 
			self::log('Item not found for URI: '.$req_uri);
			header("HTTP/1.1 404 Not found");
			die('Not found');
		}
		self::log(self::$item.' '.var_export(self::$section,1));
		if (isset(self::$section['page']))
		{
			self::log("Reserved parameter 'page' was found in section ".self::$item);
			header("HTTP/1.1 500 System error");
			die("Reserved parameter '<b>page</b>' was found in section ".self::$item);
		}
		if (isset(self::$section['base']))
		{
			self::log("Reserved parameter 'base' was found in section ".self::$item);
			header("HTTP/1.1 500 System error");
			die("Reserved parameter '<b>base</b>' was found in section ".self::$item);
		}
		self::$section = array_merge(self::$config,self::$section);
		if (isset(self::$section['content_type'])) 
			header('Content-type:  text/html; charset='.self::$section['content_type']);
	}

	
	static function partial($action,$view)
	{
		$ext = strrchr($view,'.');
		if ($action)
			include "actions/$action";
		if ($view)
		{
			if ($ext=='.haml')
			{
				require_once "inc/haml.inc.php";
				sk::$haml = new HamlParser2(array());
				eval("?".">".sk::$haml->parse(sk::$root."/views/$view"));
			}
			elseif ($ext=='.html')
				readfile(sk::$root."/views/$view");
			elseif ($ext=='.php')
				require sk::$root."/views/$view";
			else
				throw new Exception('Partial view file type is not supported: '.$view);	
		}
	}
	
	static function page()
	{
		print self::$page;
	}
	
	static function redirect($url)
	{
		print "\n<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"0;URL=$url\">";
		die();
	}
	
	static function menu($item)
	{
		if ($item==self::$item) print self::$config['selected_menu_class'];
	}
	
	static function base()
	{
		print self::$config['base'];
	}
	
	function embed_vars($s)
	{
		$m = preg_match_all('~\$([_\w][_\w\d]+)~is',$s,$machos);
		if (!$m) return $s;
		$vars = $machos[1];
		foreach($vars as $var)
			if (isset($GLOBALS[$var]))
				$s = preg_replace('~\$'.$var.'([^_\w\d]|$)~',$GLOBALS[$var].'\1',$s);	
		return $s;
	}
	
	static function create_sk()
	{
		$accessors = '';
		$accessor = '	
	static function %key%()
	{
		$values = func_get_args();
		$result = self::$section[\'%key%\'];
		$result = self::embed_vars($result);
		print $result;
	}';
		foreach(self::$section as $key=>$value)
		{
			$accessors .= str_replace('%key%',$key,$accessor)."\n\n";
		}

		$class_sk = '
	class sk extends skeletic_base
	{'.$accessors.'
	}';
		eval($class_sk);
	}
}

